// ephemera/colour.h
// Simple colour class.
// Copyright (c) 2015 Ben Michell <http://www.muryan.com/>.

// This file is part of Ephemera.
//
// Ephemera is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Ephemera is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Ephemera.  If not, see <http://www.gnu.org/licenses/>.

#ifndef EPHEMERA_COLOUR_H
#define EPHEMERA_COLOUR_H


namespace eph
{


// Simple colour class.
class rgb
{
public:

	rgb() {}
	rgb( unsigned char r, unsigned char g, unsigned char b ) : m_r( r ), m_g( g ), m_b( b ) {}
		// Construction.

	unsigned char r() const { return m_r; }
	void r( unsigned char new_r ) { m_r = new_r; }
	unsigned char g() const { return m_g; }
	void g( unsigned char new_g ) { m_g = new_g; }
	unsigned char b() const { return m_b; }
	void b( unsigned char new_b ) { m_b = new_b; }
	void set( unsigned char r, unsigned char g, unsigned char b ) { m_r = r; m_g = g; m_b = b; }
		// Colour component access.

	void from_hsv( double h, double s, double v );
		// Set the colour from HSV. All components must be in [0, 1].

private:

	unsigned char m_r;
	unsigned char m_g;
	unsigned char m_b;
};


}; // namespace eph


#endif // EPHEMERA_COLOUR_H
