// ephemera/debug.cpp
// Override assert for screen savers.
// Copyright (c) 2015 Ben Michell <http://www.muryan.com/>.

// This file is part of Ephemera.
//
// Ephemera is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Ephemera is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Ephemera.  If not, see <http://www.gnu.org/licenses/>.

#include "global.h"

#include "debug.h"


namespace eph
{


#ifndef NDEBUG

//
// Report assertion failures.
//

void
assert_report_failure( const char *condition, const char *file, int line )
{
	// Beep for the first assertion failure.
	static bool first = true;
	if ( first )
	{
		MessageBeep( (UINT) -1 );
		first = false;
	}

	// Log the failure.
	char line_str[32];
	sprintf( line_str, "%d", line );
	std::string msg = std::string( "ASSERTION FAILURE at " ) + file + ":" + line_str + ": " + condition + "\n";
	OutputDebugString( msg.c_str() );
}

#endif // NDEBUG


}; // namespace eph
