// ephemera/ifs_point.h
// Coloured point.
// Copyright (c) 2015 Ben Michell <http://www.muryan.com/>.

// This file is part of Ephemera.
//
// Ephemera is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Ephemera is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Ephemera.  If not, see <http://www.gnu.org/licenses/>.

#ifndef EPHEMERA_IFS_POINT_H
#define EPHEMERA_IFS_POINT_H


#include "colour.h"
#include "geometry.h"


namespace eph
{


// Coloured point.
class ifs_point
{
public:

	ifs_point() {}
	ifs_point( const point &p, const rgb &c ) : m_point( p ), m_colour( c ) {}
		// Construction.

	const point &pt() const { return m_point; }
	point &pt() { return m_point; }
	void pt( const point &new_point ) { m_point = new_point; }
		// Access to the point.

	const rgb &colour() const { return m_colour; }
	rgb &colour() { return m_colour; }
	void colour( const rgb &new_colour ) { m_colour = new_colour; }
		// Access to the colour.

private:

	point m_point;
	rgb m_colour;
		// Point coordinates and colour.
};


}; // namespace eph


#endif // EPHEMERA_IFS_POINT_H
