// ephemera/random.h
// Wrapper for pseudo-random number generation.
// Copyright (c) 2015 Ben Michell <http://www.muryan.com/>.

// This file is part of Ephemera.
//
// Ephemera is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Ephemera is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Ephemera.  If not, see <http://www.gnu.org/licenses/>.

#ifndef EPHEMERA_RANDOM_H
#define EPHEMERA_RANDOM_H


namespace eph
{


// Wrapper for pseudo-random number generation.
class random
{
public:

	random() {}
		// Construction.

	static int get( int min_value, int max_value );
	static int get( unsigned int min_value, unsigned int max_value );
	static double get( double min_value, double max_value );
		// Get a random number in the given range. Both end points are included.

private:

	static std::mt19937 m_random;
		// Random numbers.
};


}; // namespace eph


#endif // EPHEMERA_RANDOM_H
